diff --git a/jit/jit-context.c b/jit/jit-context.c
index 3325960..da073fb 100644
--- a/jit/jit-context.c
+++ b/jit/jit-context.c
@@ -22,6 +22,7 @@
 
 #include "jit-internal.h"
 #include "jit-cache.h"
+#include <limits.h>
 
 /*@
 
@@ -91,6 +92,14 @@ jit_context_t jit_context_create(void)
 	context->functions = 0;
 	context->last_function = 0;
 	context->on_demand_driver = _jit_function_compile_on_demand;
+	context->malloc_code_func = NULL;
+	context->resize_code_func = NULL;
+	context->free_code_func = NULL;
+	context->malloc_func = NULL;
+	context->free_func = NULL;
+	context->code_factor = 0;
+	context->code_factor_count = 0;
+	context->code_factor_total = 0;
 	return context;
 }
 
@@ -322,6 +331,46 @@ void jit_context_free_meta(jit_context_t context, int type)
 	jit_meta_free(&(context->meta), type);
 }
 
+/*@
+ * @deftypefun void jit_context_set_code_allocator(jit_context_t @var{context}, jit_alloc_code_func @var{alloc_func}, jit_resize_code_func @var{resize_func}, jit_free_code_func @var{free_func})
+ * Sets cusstom code-memory allocation functions. You should do this before
+ * any code is generated / function is compiled.
+ * @end deftypefun
+@*/
+void jit_context_set_code_allocator(jit_context_t context, 
+				    jit_malloc_code_func malloc_code_func, jit_resize_code_func resize_code_func, jit_free_code_func free_code_func,
+				    jit_malloc_func malloc_func, jit_free_func free_func)
+{
+	context->malloc_code_func 	= malloc_code_func;
+	context->resize_code_func	= resize_code_func;
+	context->free_code_func		= free_code_func;
+	context->malloc_func 		= malloc_func;
+	context->free_func		= free_func;
+	if ( malloc_code_func != 0 )
+	{
+		/* Enable estimating the size of the code based on the number of blocks. */
+		context->code_factor = sizeof(void*);
+	}
+}
+
+#include <stdio.h>
+
+int jit_context_get_code_factor(jit_context_t context)
+{
+	return context->code_factor;
+}
+
+void jit_context_update_code_factor(jit_context_t context, int code_factor)
+{
+	/* As long as we can, calculate a running average and use that plus a little bit as factor */
+	if ( context->code_factor > 0 && (INT_MAX - context->code_factor_total) > code_factor )
+	{
+		context->code_factor_count++;
+		context->code_factor_total += code_factor;
+		context->code_factor = context->code_factor_total / context->code_factor_count + 2;
+	}
+}
+
 struct jit_cache *_jit_context_get_cache(jit_context_t context)
 {
 	if(!(context->cache))
@@ -332,7 +381,13 @@ struct jit_cache *_jit_context_get_cache(jit_context_t context)
 			 (long)jit_context_get_meta_numeric
 			 	(context, JIT_OPTION_CACHE_PAGE_SIZE),
 			 (int)jit_context_get_meta_numeric
-				(context, JIT_OPTION_CACHE_MAX_PAGE_FACTOR));
+				(context, JIT_OPTION_CACHE_MAX_PAGE_FACTOR),
+			 context->malloc_code_func,
+			 context->resize_code_func,
+			 context->free_code_func,
+			 context->malloc_func,
+			 context->free_func
+			);
 	}
 	return context->cache;
 }
diff --git a/jit/jit-function.c b/jit/jit-function.c
index 3cdc580..2879b59 100644
--- a/jit/jit-function.c
+++ b/jit/jit-function.c
@@ -60,7 +60,7 @@ jit_function_t jit_function_create(jit_context_t context, jit_type_t signature)
 
 #if !defined(JIT_BACKEND_INTERP) && (defined(jit_redirector_size) || defined(jit_indirector_size))
 	/* TODO: if the function is destroyed the redirector and indirector memory
-	   is leaked */
+	   is leaked -> Not with a custom allocator. */
 
 	/* We need the cache lock while we are allocating redirector and indirector */
 	jit_mutex_lock(&(context->cache_lock));
@@ -76,21 +76,21 @@ jit_function_t jit_function_create(jit_context_t context, jit_type_t signature)
 
 # if defined(jit_redirector_size)
 	/* Allocate redirector buffer */
-	func->redirector = _jit_cache_alloc_no_method(cache, jit_redirector_size, 1);
+	func->redirector = _jit_cache_alloc_code(cache, jit_redirector_size);
 	if(!func->redirector)
 	{
 		jit_mutex_unlock(&(context->cache_lock));
-		jit_free(func);
+		_jit_function_destroy(func);
 		return 0;
 	}
 # endif
 # if defined(jit_indirector_size)
 	/* Allocate indirector buffer */
-	func->indirector = _jit_cache_alloc_no_method(cache, jit_indirector_size, 1);
+	func->indirector = _jit_cache_alloc_code(cache, jit_indirector_size);
 	if(!func->indirector)
 	{
 		jit_mutex_unlock(&(context->cache_lock));
-		jit_free(func);
+		_jit_function_destroy(func);
 		return 0;
 	}
 # endif
@@ -260,6 +260,8 @@ void _jit_function_destroy(jit_function_t func)
 	_jit_function_free_builder(func);
 	jit_meta_destroy(&(func->meta));
 	jit_type_free(func->signature);
+	_jit_cache_free_code(func->context->cache, func->redirector);
+	_jit_cache_free_code(func->context->cache, func->indirector);
 	jit_free(func);
 }
 
@@ -292,6 +294,31 @@ void jit_function_abandon(jit_function_t func)
 }
 
 /*@
+ * @deftypefun void jit_function_free (jit_function_t @var{func})
+ * Free this function. The @var{func} object is completely destroyed and
+ * detached from its owning context. All associated resources are freed.
+ * Currently, the internal memory manager will NOT free the code memory.
+ * @end deftypefun
+@*/
+void jit_function_free(jit_function_t func)
+{
+	if(!func)
+	{
+		return;
+	}
+	if ( func->entry_point )
+	{
+		/* Acquire the cache lock */
+		jit_mutex_lock(&func->context->cache_lock);
+		jit_cache_t cache = _jit_context_get_cache(func->context);
+		_jit_cache_free_method(cache, func->entry_point);
+		jit_mutex_unlock(&func->context->cache_lock);
+	}
+
+	_jit_function_destroy(func);
+}
+
+/*@
  * @deftypefun jit_context_t jit_function_get_context (jit_function_t @var{func})
  * Get the context associated with a function.
  * @end deftypefun
diff --git a/jit/jit-gen-x86-64.h b/jit/jit-gen-x86-64.h
index 2a15ee7..996e2f3 100644
--- a/jit/jit-gen-x86-64.h
+++ b/jit/jit-gen-x86-64.h
@@ -26,6 +26,10 @@
 #include <jit/jit-defs.h>
 #include "jit-gen-x86.h"
 
+#if defined(__CYGWIN64__) || defined(_WIN64)
+#define WIN64
+#endif
+
 #ifdef	__cplusplus
 extern	"C" {
 #endif
diff --git a/jit/jit-insn.c b/jit/jit-insn.c
index b1dd2e2..07caed8 100644
--- a/jit/jit-insn.c
+++ b/jit/jit-insn.c
@@ -4278,6 +4278,25 @@ static jit_value_t apply_unary_conversion
 }
 
 /*@
+ * @deftypefun int jit_insn_cast (jit_function_t @var{func}, jit_value_t @var{value}, jit_type_t @var{type})
+ * Change the type of a value to a different type with the same size.
+ * @end deftypefun
+@*/
+int jit_insn_cast(jit_function_t func, jit_value_t value, jit_type_t type)
+{
+	if (value->type != type)
+	{
+		if (value->type->size != type->size)
+		{
+			return 0;
+		}
+		jit_type_free(value->type);
+		value->type = jit_type_copy(type);
+	}
+	return 1;
+}
+
+/*@
  * @deftypefun jit_value_t jit_insn_convert (jit_function_t @var{func}, jit_value_t @var{value}, jit_type_t @var{type}, int @var{overflow_check})
  * Convert the contents of a value into a new type, with optional
  * overflow checking.
@@ -5054,6 +5073,13 @@ jit_value_t jit_insn_convert(jit_function_t func, jit_value_t value,
 			value = apply_unary_conversion
 				(func, opcode_map->cvt3, value, opcode_map->type3);
 		}
+    
+		// Make sure we're actually the type we asked to convert to, and not some derivated type.
+		if ( value->type != type && jit_type_normalize(jit_value_get_type(value)) == jit_type_normalize(type) )
+		{
+			jit_type_free(value->type);
+			value->type = jit_type_copy(type);
+		}
 	}
 	return value;
 }
@@ -5985,6 +6011,13 @@ jit_value_t jit_insn_call_native
 		break;
 	}
 
+	// Make sure we're actually the type we asked to convert to, and not some derivated type.
+	if ( return_value->type != jit_type_get_return(signature) )
+	{
+		jit_type_free(return_value->type);
+		return_value->type = jit_type_copy(jit_type_get_return(signature));
+	}
+
 	/* Return the value containing the result to the caller */
 	return return_value;
 }
diff --git a/jit/jit-internal.h b/jit/jit-internal.h
index 35961ab..1ff90b5 100644
--- a/jit/jit-internal.h
+++ b/jit/jit-internal.h
@@ -549,6 +549,16 @@ struct _jit_context
 
 	/* On-demand compilation driver */
 	jit_on_demand_driver_func	on_demand_driver;
+	
+	/* plugable memmory management members */
+	jit_malloc_code_func	malloc_code_func;
+	jit_resize_code_func	resize_code_func;
+	jit_free_code_func	free_code_func;
+	jit_malloc_func		malloc_func;
+	jit_free_func		free_func;
+	int			code_factor_total;
+	int			code_factor_count;
+	int			code_factor;
 };
 
 /*
diff --git a/jit/jit-reg-alloc.c b/jit/jit-reg-alloc.c
index 21798c6..aac2de3 100644
--- a/jit/jit-reg-alloc.c
+++ b/jit/jit-reg-alloc.c
@@ -2648,7 +2648,7 @@ _jit_regs_lookup(char *name)
 	{
 		for(reg = 0; reg < JIT_NUM_REGS; reg++)
 		{
-			if(strcmp(jit_reg_name(reg), name) == 0)
+			if(strcmp(jit_reg_name(reg), name) == 0 || strcmp(jit_reg_alias(reg), name) == 0)
 			{
 				return reg;
 			}
@@ -2911,8 +2911,10 @@ _jit_regs_set_outgoing(jit_gencode_t gen, int reg, jit_value_t value)
 	if(value->in_register && value->reg == reg)
 	{
 		/* The value is already in the register, but we may need to spill
-		   if the frame copy is not up to date with the register */
-		if(!(value->in_global_register || value->in_frame))
+		   if the frame copy is not up to date with the register.
+		   If the usage_count <= 1 then this is the one and only used and
+		   we don't need to spill it. */
+		if( !(value->in_global_register || value->in_frame) && value->usage_count > 1 )
 		{
 			save_value(gen, value, reg, other_reg, 0);
 		}
diff --git a/jit/jit-rules-alpha.h b/jit/jit-rules-alpha.h
index 131267f..3d8f6cf 100644
--- a/jit/jit-rules-alpha.h
+++ b/jit/jit-rules-alpha.h
@@ -66,70 +66,70 @@ extern	"C" {
  * $f31 - Contains the value 0.0.
  */
 #define JIT_REG_INFO	\
-	{   "v0",  0, -1, JIT_REG_FIXED}, \
-	{   "t0",  1, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "t1",  2, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "t2",  3, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "t3",  4, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "t4",  5, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "t5",  6, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "t6",  7, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "t7",  8, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "s0",  9, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
- 	{   "s1", 10, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
-	{   "s2", 11, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
-	{   "s3", 12, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
-	{   "s4", 13, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
-	{   "s5", 14, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
-	{   "fp", 15, -1, JIT_REG_FIXED | JIT_REG_FRAME}, \
-	{   "a0", 16, -1, JIT_REG_FIXED}, \
-	{   "a1", 17, -1, JIT_REG_FIXED}, \
-	{   "a2", 18, -1, JIT_REG_FIXED}, \
-	{   "a3", 19, -1, JIT_REG_FIXED}, \
-	{   "a4", 20, -1, JIT_REG_FIXED}, \
-	{   "a5", 21, -1, JIT_REG_FIXED}, \
-	{   "t8", 22, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "t9", 23, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{  "t10", 24, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{  "t11", 25, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
-	{   "ra", 26, -1, JIT_REG_FIXED}, \
-	{   "pv", 27, -1, JIT_REG_FIXED}, \
-	{   "at", 28, -1, JIT_REG_FIXED}, \
-	{   "gp", 29, -1, JIT_REG_FIXED}, \
-	{   "sp", 30, -1, JIT_REG_FIXED | JIT_REG_STACK_PTR}, \
-	{ "zero", 31, -1, JIT_REG_FIXED}, \
-	{  "fv0", 0, -1, JIT_REG_FIXED}, \
-	{  "fv1", 1, -1, JIT_REG_FIXED}, \
-	{  "fs0", 2, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
-	{  "fs1", 3, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
-	{  "fs2", 4, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
-	{  "fs3", 5, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
-	{  "fs4", 6, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
-	{  "fs5", 7, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
-	{  "fs6", 8, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
-	{  "fs7", 9, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
-	{  "ft0", 10, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
-	{  "ft1", 11, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
-	{  "ft2", 12, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
-	{  "ft3", 13, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
-	{  "ft4", 14, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
-	{  "ft5", 15, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
-	{  "fa0", 16, -1, JIT_REG_FIXED}, \
-	{  "fa1", 17, -1, JIT_REG_FIXED}, \
-	{  "fa2", 18, -1, JIT_REG_FIXED}, \
-	{  "fa3", 19, -1, JIT_REG_FIXED}, \
-	{  "fa4", 20, -1, JIT_REG_FIXED}, \
-	{  "fa5", 21, -1, JIT_REG_FIXED}, \
-	{  "fe0", 22, -1, JIT_REG_FIXED}, \
-	{  "fe1", 23, -1, JIT_REG_FIXED}, \
-	{  "fe2", 24, -1, JIT_REG_FIXED}, \
-	{  "fe3", 25, -1, JIT_REG_FIXED}, \
-	{  "fe4", 26, -1, JIT_REG_FIXED}, \
-	{  "fe5", 27, -1, JIT_REG_FIXED}, \
-	{  "fe6", 28, -1, JIT_REG_FIXED}, \
-	{  "fe7", 29, -1, JIT_REG_FIXED}, \
-	{  "fe8", 30, -1, JIT_REG_FIXED}, \
-	{"fzero", 31, -1, JIT_REG_FIXED},
+	{   "v0", NULL,  0, -1, JIT_REG_FIXED}, \
+	{   "t0", NULL,  1, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "t1", NULL,  2, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "t2", NULL,  3, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "t3", NULL,  4, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "t4", NULL,  5, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "t5", NULL,  6, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "t6", NULL,  7, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "t7", NULL,  8, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "s0", NULL,  9, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
+ 	{   "s1", NULL, 10, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
+	{   "s2", NULL, 11, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
+	{   "s3", NULL, 12, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
+	{   "s4", NULL, 13, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
+	{   "s5", NULL, 14, -1, JIT_REG_ALPHA_INT | JIT_REG_GLOBAL}, \
+	{   "fp", NULL, 15, -1, JIT_REG_FIXED | JIT_REG_FRAME}, \
+	{   "a0", NULL, 16, -1, JIT_REG_FIXED}, \
+	{   "a1", NULL, 17, -1, JIT_REG_FIXED}, \
+	{   "a2", NULL, 18, -1, JIT_REG_FIXED}, \
+	{   "a3", NULL, 19, -1, JIT_REG_FIXED}, \
+	{   "a4", NULL, 20, -1, JIT_REG_FIXED}, \
+	{   "a5", NULL, 21, -1, JIT_REG_FIXED}, \
+	{   "t8", NULL, 22, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "t9", NULL, 23, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{  "t10", NULL, 24, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{  "t11", NULL, 25, -1, JIT_REG_ALPHA_INT | JIT_REG_CALL_USED}, \
+	{   "ra", NULL, 26, -1, JIT_REG_FIXED}, \
+	{   "pv", NULL, 27, -1, JIT_REG_FIXED}, \
+	{   "at", NULL, 28, -1, JIT_REG_FIXED}, \
+	{   "gp", NULL, 29, -1, JIT_REG_FIXED}, \
+	{   "sp", NULL, 30, -1, JIT_REG_FIXED | JIT_REG_STACK_PTR}, \
+	{ "zero", NULL, 31, -1, JIT_REG_FIXED}, \
+	{  "fv0", NULL, 0, -1, JIT_REG_FIXED}, \
+	{  "fv1", NULL, 1, -1, JIT_REG_FIXED}, \
+	{  "fs0", NULL, 2, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
+	{  "fs1", NULL, 3, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
+	{  "fs2", NULL, 4, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
+	{  "fs3", NULL, 5, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
+	{  "fs4", NULL, 6, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
+	{  "fs5", NULL, 7, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
+	{  "fs6", NULL, 8, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
+	{  "fs7", NULL, 9, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_GLOBAL}, \
+	{  "ft0", NULL, 10, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
+	{  "ft1", NULL, 11, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
+	{  "ft2", NULL, 12, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
+	{  "ft3", NULL, 13, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
+	{  "ft4", NULL, 14, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
+	{  "ft5", NULL, 15, -1, JIT_REG_ALPHA_FLOAT | JIT_REG_CALL_USED}, \
+	{  "fa0", NULL, 16, -1, JIT_REG_FIXED}, \
+	{  "fa1", NULL, 17, -1, JIT_REG_FIXED}, \
+	{  "fa2", NULL, 18, -1, JIT_REG_FIXED}, \
+	{  "fa3", NULL, 19, -1, JIT_REG_FIXED}, \
+	{  "fa4", NULL, 20, -1, JIT_REG_FIXED}, \
+	{  "fa5", NULL, 21, -1, JIT_REG_FIXED}, \
+	{  "fe0", NULL, 22, -1, JIT_REG_FIXED}, \
+	{  "fe1", NULL, 23, -1, JIT_REG_FIXED}, \
+	{  "fe2", NULL, 24, -1, JIT_REG_FIXED}, \
+	{  "fe3", NULL, 25, -1, JIT_REG_FIXED}, \
+	{  "fe4", NULL, 26, -1, JIT_REG_FIXED}, \
+	{  "fe5", NULL, 27, -1, JIT_REG_FIXED}, \
+	{  "fe6", NULL, 28, -1, JIT_REG_FIXED}, \
+	{  "fe7", NULL, 29, -1, JIT_REG_FIXED}, \
+	{  "fe8", NULL, 30, -1, JIT_REG_FIXED}, \
+	{"fzero", NULL, 31, -1, JIT_REG_FIXED},
 
 /* 32 floating-point registers + 32 integer registers */
 #define JIT_NUM_REGS			64
diff --git a/jit/jit-rules-arm.h b/jit/jit-rules-arm.h
index 1797e00..7645a7f 100644
--- a/jit/jit-rules-arm.h
+++ b/jit/jit-rules-arm.h
@@ -57,22 +57,22 @@ extern	"C" {
  * The definitions of the used flags are in jit-rules.h
  */
 #define	JIT_REG_INFO	\
-	{"r0",   0,  1, JIT_REG_WORD | JIT_REG_LONG | JIT_REG_CALL_USED}, \
-	{"r1",   1, -1, JIT_REG_WORD | JIT_REG_CALL_USED}, \
-	{"r2",   2,  3, JIT_REG_WORD | JIT_REG_LONG | JIT_REG_CALL_USED}, \
-	{"r3",   3, -1, JIT_REG_WORD | JIT_REG_CALL_USED}, \
-	{"r4",   4, -1, JIT_REG_WORD}, \
-	{"r5",   5, -1, JIT_REG_WORD}, \
-	{"r6",   6, -1, JIT_REG_WORD | JIT_REG_GLOBAL},	\
-	{"r7",   7, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
-	{"r8",   8, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
-	{"r9",   9, -1, JIT_REG_FIXED}, /* pic reg */ \
-	{"r10", 10, -1, JIT_REG_FIXED}, /* stack limit */ \
-	{"fp",  11, -1, JIT_REG_FIXED | JIT_REG_FRAME},	\
-	{"r12", 12, -1, JIT_REG_FIXED | JIT_REG_CALL_USED}, /* work reg */ \
-	{"sp",  13, -1, JIT_REG_FIXED | JIT_REG_STACK_PTR}, \
-	{"lr",  14, -1, JIT_REG_FIXED}, \
-	{"pc",  15, -1, JIT_REG_FIXED}, \
+	{"r0", NULL,   0,  1, JIT_REG_WORD | JIT_REG_LONG | JIT_REG_CALL_USED}, \
+	{"r1", NULL,   1, -1, JIT_REG_WORD | JIT_REG_CALL_USED}, \
+	{"r2", NULL,   2,  3, JIT_REG_WORD | JIT_REG_LONG | JIT_REG_CALL_USED}, \
+	{"r3", NULL,   3, -1, JIT_REG_WORD | JIT_REG_CALL_USED}, \
+	{"r4", NULL,   4, -1, JIT_REG_WORD}, \
+	{"r5", NULL,   5, -1, JIT_REG_WORD}, \
+	{"r6", NULL,   6, -1, JIT_REG_WORD | JIT_REG_GLOBAL},	\
+	{"r7", NULL,   7, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
+	{"r8", NULL,   8, -1, JIT_REG_WORD | JIT_REG_GLOBAL}, \
+	{"r9", NULL,   9, -1, JIT_REG_FIXED}, /* pic reg */ \
+	{"r10", NULL, 10, -1, JIT_REG_FIXED}, /* stack limit */ \
+	{"fp", NULL,  11, -1, JIT_REG_FIXED | JIT_REG_FRAME},	\
+	{"r12", NULL, 12, -1, JIT_REG_FIXED | JIT_REG_CALL_USED}, /* work reg */ \
+	{"sp", NULL,  13, -1, JIT_REG_FIXED | JIT_REG_STACK_PTR}, \
+	{"lr", NULL,  14, -1, JIT_REG_FIXED}, \
+	{"pc", NULL,  15, -1, JIT_REG_FIXED}, \
 	JIT_REG_INFO_FLOAT_REGS
 
 /*
@@ -96,10 +96,10 @@ extern	"C" {
 	(JIT_REG_FLOAT32 | JIT_REG_FLOAT64 | JIT_REG_NFLOAT | JIT_REG_CALL_USED)
 
 #define JIT_REG_INFO_FLOAT_REGS	\
-	{"f0",   0, -1, JIT_REG_ARM_FLOAT}, \
-	{"f1",   1, -1, JIT_REG_ARM_FLOAT}, \
-	{"f2",   2, -1, JIT_REG_ARM_FLOAT}, \
-	{"f3",   3, -1, JIT_REG_ARM_FLOAT},
+	{"f0", NULL,   0, -1, JIT_REG_ARM_FLOAT}, \
+	{"f1", NULL,   1, -1, JIT_REG_ARM_FLOAT}, \
+	{"f2", NULL,   2, -1, JIT_REG_ARM_FLOAT}, \
+	{"f3", NULL,   3, -1, JIT_REG_ARM_FLOAT},
 
 /* JIT_NUM_REGS is the total number of registers (general purpose+floating point) */
 #define	JIT_NUM_REGS		20
@@ -115,30 +115,30 @@ extern	"C" {
 #define JIT_REG_ARM_FLOAT64	(JIT_REG_FLOAT64 | JIT_REG_NFLOAT)
 
 #define JIT_REG_INFO_FLOAT_REGS	\
-	{"s0",   0, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s1",   1, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s2",   2, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s3",   3, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s4",   4, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s5",   5, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s6",   6, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s7",   7, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s8",   8, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s9",   9, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s10",   10, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s11",   11, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s12",   12, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s13",   13, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s14",   14, -1, JIT_REG_ARM_FLOAT32}, \
-	{"s15",   15, -1, JIT_REG_ARM_FLOAT32}, \
-	{"d8",   8, -1, JIT_REG_ARM_FLOAT64},	\
-	{"d9",   9, -1, JIT_REG_ARM_FLOAT64},	\
-	{"d10",   10, -1, JIT_REG_ARM_FLOAT64},	\
-	{"d11",   11, -1, JIT_REG_ARM_FLOAT64},	\
-	{"d12",   12, -1, JIT_REG_ARM_FLOAT64},	\
-	{"d13",   13, -1, JIT_REG_ARM_FLOAT64},	\
-	{"d14",   14, -1, JIT_REG_ARM_FLOAT64},	\
-	{"d15",   15, -1, JIT_REG_ARM_FLOAT64},
+	{"s0", NULL,   0, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s1", NULL,   1, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s2", NULL,   2, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s3", NULL,   3, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s4", NULL,   4, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s5", NULL,   5, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s6", NULL,   6, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s7", NULL,   7, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s8", NULL,   8, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s9", NULL,   9, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s10", NULL,   10, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s11", NULL,   11, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s12", NULL,   12, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s13", NULL,   13, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s14", NULL,   14, -1, JIT_REG_ARM_FLOAT32}, \
+	{"s15", NULL,   15, -1, JIT_REG_ARM_FLOAT32}, \
+	{"d8", NULL,   8, -1, JIT_REG_ARM_FLOAT64},	\
+	{"d9", NULL,   9, -1, JIT_REG_ARM_FLOAT64},	\
+	{"d10", NULL,   10, -1, JIT_REG_ARM_FLOAT64},	\
+	{"d11", NULL,   11, -1, JIT_REG_ARM_FLOAT64},	\
+	{"d12", NULL,   12, -1, JIT_REG_ARM_FLOAT64},	\
+	{"d13", NULL,   13, -1, JIT_REG_ARM_FLOAT64},	\
+	{"d14", NULL,   14, -1, JIT_REG_ARM_FLOAT64},	\
+	{"d15", NULL,   15, -1, JIT_REG_ARM_FLOAT64},
 
 /* JIT_NUM_REGS is the total number of registers (general purpose+floating point) */
 #define JIT_NUM_REGS		40
diff --git a/jit/jit-rules-interp.h b/jit/jit-rules-interp.h
index d5a1022..2b00d08 100644
--- a/jit/jit-rules-interp.h
+++ b/jit/jit-rules-interp.h
@@ -33,9 +33,9 @@ extern	"C" {
  * Information about all of the registers, in allocation order.
  */
 #define	JIT_REG_INFO \
-	{"r0", 0, -1, JIT_REG_ALL | JIT_REG_CALL_USED}, \
-	{"r1", 1, -1, JIT_REG_ALL | JIT_REG_CALL_USED}, \
-	{"r2", 2, -1, JIT_REG_ALL | JIT_REG_CALL_USED},
+	{"r0", NULL, 0, -1, JIT_REG_ALL | JIT_REG_CALL_USED}, \
+	{"r1", NULL, 1, -1, JIT_REG_ALL | JIT_REG_CALL_USED}, \
+	{"r2", NULL, 2, -1, JIT_REG_ALL | JIT_REG_CALL_USED},
 #define	JIT_NUM_REGS		3
 #define	JIT_NUM_GLOBAL_REGS	0
 
